﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;

using System.ComponentModel;
using System.Threading;

namespace bounce1
{
    public partial class MainPage : UserControl
    {
        BackgroundWorker bw = new BackgroundWorker();
        public MainPage()
        {
            InitializeComponent();
          
            bw.WorkerSupportsCancellation = true;
            bw.WorkerReportsProgress= true;
            bw.DoWork += (o1, e1) =>
            {
                do
                {
                    if (((BackgroundWorker)o1).CancellationPending)
                    {
                        e1.Cancel = true;
                        break;
                    }
                    bw.ReportProgress(1, (object) vx);
                    Thread.Sleep(5);
                } while (true);
             };

            bw.ProgressChanged += new ProgressChangedEventHandler(update);
        }

        int vx = 1;
        int vy = 1;
        private void button1_Click(object sender, RoutedEventArgs e)
        {
            bw.RunWorkerAsync();
        }

      
        void update(object o, ProgressChangedEventArgs e)
        {
           
            Canvas.SetLeft(rectangle1, Canvas.GetLeft(rectangle1) + vx);
            Canvas.SetTop(rectangle1, Canvas.GetTop(rectangle1) + vy);
            if(Canvas.GetLeft(rectangle1)<=0 || (Canvas.GetLeft(rectangle1)+rectangle1.Width)>=(canvas1.Width-1)) vx=-vx;
            if(Canvas.GetTop(rectangle1)<=0 || (Canvas.GetTop(rectangle1)+rectangle1.Height)>=(canvas1.Height-1)) vy=-vy;
        }

        private void button2_Click(object sender, RoutedEventArgs e)
        {
            bw.CancelAsync();
        }
        
    }
}
